'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactResizable = require('react-resizable');

var _MuiThemeProvider = require('material-ui/styles/MuiThemeProvider');

var _MuiThemeProvider2 = _interopRequireDefault(_MuiThemeProvider);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _TextField = require('material-ui/TextField');

var _TextField2 = _interopRequireDefault(_TextField);

var _oryEditorUi = require('ory-editor-ui');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var faintBlack = 'rgba(0, 0, 0, 0.12)';

var compute = function compute(_ref) {
  var height = _ref.height;
  return {
    height: height > 24 ? height : 24
  };
};

var fire = function fire(_ref2) {
  var state = _ref2.state,
      onChange = _ref2.onChange;
  return onChange(state);
};

var Solid = function Solid(_ref3) {
  var height = _ref3.height;
  return _react2.default.createElement('div', { style: { height: height } });
};

var handleChange = function handleChange(onChange) {
  return function (e) {
    var target = e.target;
    if (target instanceof HTMLInputElement) {
      onChange({ height: parseInt(target.value) });
      return;
    }
  };
};

var Spacer = function (_Component) {
  _inherits(Spacer, _Component);

  function Spacer() {
    var _ref4;

    var _temp, _this, _ret;

    _classCallCheck(this, Spacer);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref4 = Spacer.__proto__ || Object.getPrototypeOf(Spacer)).call.apply(_ref4, [this].concat(args))), _this), _this.state = {}, _this.onResize = function (event, _ref5) {
      var size = _ref5.size;
      var onChange = _this.props.onChange;

      var state = compute(size);
      fire({ onChange: onChange, state: state });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Spacer, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          readOnly = _props.readOnly,
          isPreviewMode = _props.isPreviewMode,
          focused = _props.focused,
          onChange = _props.onChange;

      var height = this.props.state.height > 0 ? this.props.state.height : 1;

      return _react2.default.createElement(
        'div',
        {
          style: { border: 'solid 1px', borderColor: faintBlack },
          className: (0, _classnames2.default)('ory-plugins-content-spacer', {
            'ory-plugins-content-spacer-read-only': isPreviewMode
          })
        },
        readOnly ? _react2.default.createElement(Solid, { height: height }) : _react2.default.createElement(
          _reactResizable.Resizable,
          { onResize: this.onResize, height: height, width: 0 },
          _react2.default.createElement(
            'div',
            { style: { height: height, position: 'relative' } },
            _react2.default.createElement(
              _MuiThemeProvider2.default,
              null,
              _react2.default.createElement(
                _oryEditorUi.BottomToolbar,
                { open: focused },
                _react2.default.createElement(_TextField2.default, {
                  hintText: '24',
                  floatingLabelText: 'Element height (px)',
                  inputStyle: { color: 'white' },
                  floatingLabelStyle: { color: 'white' },
                  hintStyle: { color: 'grey' },
                  style: { width: '512px' },
                  value: height,
                  onChange: handleChange(onChange)
                })
              )
            ),
            _react2.default.createElement(
              'div',
              {
                style: {
                  position: 'absolute',
                  bottom: '0',
                  height: '24px',
                  width: '100%',
                  background: faintBlack,
                  textAlign: 'center'
                }
              },
              _react2.default.createElement(
                'svg',
                {
                  viewBox: '0 0 24 24',
                  style: { color: 'white', width: 24, height: 24 }
                },
                _react2.default.createElement('path', { d: 'M20 9H4v2h16V9zM4 15h16v-2H4v2z' })
              )
            )
          )
        )
      );
    }
  }]);

  return Spacer;
}(_react.Component);

exports.default = Spacer;
//# sourceMappingURL=index.js.map